{% extends 'shared/_dashboard.html' %}
{% load static %}
{% load widget_tweaks %}

{% block styles %}
<link rel="stylesheet" href="https://unpkg.com/@fortawesome/fontawesome-free@5.12.1/css/all.min.css">
{% endblock %}

{% block body %}
<div class="container-fluid">
    <div class="row">
        <div class="col-12">

            <h1>Account Management</h1>
            <nav class="breadcrumb-container d-none d-sm-block d-lg-inline-block" aria-label="breadcrumb">
                <ol class="breadcrumb pt-0">
                    <li class="breadcrumb-item">
                        <a href="{% url 'dashboard:home' %}">Home</a>
                    </li>
                    <li class="breadcrumb-item active" aria-current="page">Applications</li>
                </ol>
            </nav>
            <div class="separator mb-5"></div>
        </div>
    </div>

    <div class="row">
        <div class="col-12 col-lg-12 mb-5">

            <div class="card mb-4">
                <div class="card-body">
                    
                    {% if messages %}
                        {% for message in messages %}
                            <div class="alert alert-success">
                                <li {% if message.tags %}class="{{ message.tags }}"{% endif %}>{{ message }}</li>
                            </div>
                        {% endfor %}
                    {% endif %}
                    
                    <h5 style="float: left;" class="mb-4">Your applications</h5>

                    <div style="float: right;">
                        <button type="button" class="btn btn-danger btn-lg" data-toggle="modal" data-target="#check">Create new application</button>
                    </div> 

                    <div class="container">
                        <div class="modal fade" id="check" role="dialog">
                            <div class="modal-dialog">
                                <div class="modal-content">
                                    <div class="modal-header">
                                        <h4 class="modal-title">Warning</h4>
                                    </div>
                                    <div class="modal-body">
                                        {% if user.profile.is_published %}
                                            <p>Are you sure you want to create a new application?
                                            </p>
                                        {% else %}
                                            <p>Application is not available when you didn't complete your profile. Please visit profile link and finalize your profile.
                                            </p>
                                        {% endif %}
                                    </div>

                                    {% if request.user.profile.is_published %}
                                        <div class="modal-footer">
                                            <form method="POST" id="application-create" action="{% url 'dashboard:application-create' request.user.pk %}">
                                                {% csrf_token %}
                                                <input type="hidden" name="g-recaptcha-response" id='recaptcha'>
                                                <button style="float: right;" type="submit" class="btn btn-info">Yes</button>
                                            </form>
                                            <button style="float: right;" class="btn btn-danger" data-dismiss="modal">No</button>
                                        </div>
                                    {% else %}
                                        <div class="modal-footer">
                                            <button style="float: right;" class="btn btn-danger" data-dismiss="modal">Cancel</button>
                                        </div>
                                    {% endif %}
                                </div>
                            </div>
                        </div>

                        <div class="modal fade" id="projectModal" role="dialog">
                            <div class="modal-dialog">
                                <div class="modal-content">
                                    <div class="modal-header">
                                        <h4 class="modal-title">Information</h4>
                                    </div>
                                    <div class="modal-body">
                                        
                                        <p>First you must finalize your application.</p>
                                    </div>

                                    <div class="modal-footer">
                                        <button style="float: right;" class="btn btn-danger" data-dismiss="modal">No</button>
                                    </div>
                                </div>
                            </div>
                        </div>
                    </div>

                    <div class="clearfix"></div>
                    <hr/>
                    <table style="text-align: center;"
                        id="table"
                        data-toggle="table"
                        data-total-field="count"
                        data-data-field="results"
                        data-show-refresh="true"
                        data-resizable="true"
                        data-show-fullscreen="true"
                        data-buttons-class="primary"
                        data-ajax="ajaxRequest">
                        <thead>
                            <tr>
                                <th data-field="sku" data-width="100" data-formatter="operateApplication" data-events="operateApplicationEvents">ID</th>
                                <th data-field="industry">Industry</th>
                                <th data-field="qatari_partnership" data-formatter="operatePartnership">Qatari partnership</th>
                                <th data-field="has_product" data-formatter="operateProduct">Has product</th>
                                <th data-field="is_published" data-formatter="operateFinalized">Finalized</th>
                                
                            </tr>
                        </thead>
                        </table>


                </div>
            </div>
        </div>
    </div>
</div>

{% endblock %}

{% block scripts %}
<script>
    // your custom ajax request here
    function ajaxRequest(params) {
      var url = '/api/v1/accounts/applications/'

      $.get(url + '?' + $.param(params.data)).then(function (res) {
        params.success(res)
      });
    }

    function operateApplication(value, row, index) {
        return [
          '<a class="modify btn btn-outline-primary btn-sm mb-1" href="javascript:void(0)" title="modify">',
            row.sku,
          '</a>  ',
        ].join('')
      }
      window.operateApplicationEvents = {
        'click .modify': function (e, value, row, index) {
            
            window.location.href = "/dashboard/account/application/"+ row.sku;
        },
      }

    function operateProject(value, row, index) {
        console.log(row)
        return [
          '<a class="project-modal btn btn-outline-info btn-sm mb-1" href="javascript:void(0)" data-application="' + row.sku + '" data-finalize="' + row.is_published + '" data-project="' + row.project + '" data-toggle="modal" data-target="#projectModal">',
            'Project',
          '</a>  ',
        ].join('')
      }
    function operateProduct(value, row, index) {
        if (row.has_product == true){
            return [
              '<span style="color: #17a2b8; font-size: 20px; position: relative; top:5px;" class="glyph-icon simple-icon-check"></span>',
            ].join('')
        }else {
            return [
              '<span style="color: #dc3545; font-size: 20px; position: relative; top:5px;" class="glyph-icon simple-icon-close"></span>',
            ].join('')
        }
      }
    function operatePartnership(value, row, index) {
        if (row.qatari_partnership == true){
            return [
              '<span style="color: #17a2b8; font-size: 20px; position: relative; top:5px;" class="glyph-icon simple-icon-check"></span>',
            ].join('')
        }else {
            return [
              '<span style="color: #dc3545; font-size: 20px; position: relative; top:5px;" class="glyph-icon simple-icon-close"></span>',
            ].join('')
        }
      }
    function operateFinalized(value, row, index) {
        if (row.is_published == true){
            return [
              '<span style="color: #17a2b8; font-size: 20px; position: relative; top:5px;" class="glyph-icon simple-icon-check"></span>',
            ].join('')
        }else {
            return [
              '<span style="color: #f18024; font-size: 20px; position: relative; top:5px;" class="glyph-icon simple-icon-exclamation"></span>',
            ].join('')
        }
      }

  </script>

  <script>
      $('#projectModal').on('show.bs.modal', function (e) {
          var finalize_status = $(e.relatedTarget).data('finalize');
          var application = $(e.relatedTarget).data('application');
          var project = $(e.relatedTarget).data('project');
          var text = '';

          if (finalize_status == true) {
              text = 'Do you want to view your application\'s project ?';
              html = '<a href="/dashboard/account/application/' + application + '/project/' + project + '" class="btn btn-primary">Yes</a><button style="float: right;" class="btn btn-danger" data-dismiss="modal">No</button>'
          } else {
              text = 'You must first finalize your application form.';
              html = '<button style="float: right;" class="btn btn-info" data-dismiss="modal">OK</button>';
          }
          $(this).find(".modal-body").text(text);
          $(this).find(".modal-footer").html(html);
        });
  </script>

    <script src="https://www.google.com/recaptcha/api.js?render=6LfZsvgUAAAAAJX02IjM58aIqO5y-g60SRJGPR4A"></script>
    <script>
        grecaptcha.ready(function() {
            $('#application-draft').submit(function(e){
                var form = this;
                e.preventDefault()
                grecaptcha.execute('6LfZsvgUAAAAAJX02IjM58aIqO5y-g60SRJGPR4A', {action: 'recaptcha'}).then(function(token) {
                    $('#recaptcha').val(token)
                    form.submit()
                });
            })
        });
    </script>

    <script>
      grecaptcha.ready(function() {
          $('#application-create').submit(function(e){
              var form = this;
              e.preventDefault()
              grecaptcha.execute('6LfZsvgUAAAAAJX02IjM58aIqO5y-g60SRJGPR4A', {action: 'recaptcha'}).then(function(token) {
                  $('#recaptcha').val(token)
                  form.submit()
              });
          })    
      });
  </script>

{% endblock %}
